/*
|--------------------------------------------------------------------------
| JavaScript-функции, используемые в админ. панели.
|--------------------------------------------------------------------------
|
| Содержит функционал, перенесенный из `{{ home }}/lib/admin.js`.
|
*/

/**
 * [ngShowLoading description]
 */
export function ngShowLoading() {
    const setX = ($(window).width() - $("#loading-layer").width()) / 2;
    const setY = ($(window).height() - $("#loading-layer").height()) / 2;

    $("#loading-layer").css({
            left: setX + 'px',
            top: setY + 'px'
        })
        .fadeIn(0);
}

/**
 * [ngHideLoading description]
 */
export function ngHideLoading() {
    $("#loading-layer").fadeOut('slow');
}

/**
 * [ngNotifySticker description]
 * @param  {string}  message
 * @param  {object}  params
 */
export function ngNotifySticker(message, params = {}) {
    // настройки по умолчанию
    params = $.extend({
        time: 5000, // количество мс, которое отображается сообщение
        speed: 'slow', // скорость исчезания
        className: 'alert-info', // класс, добавляемый к сообщению
        sticked: false, // не закреплять сообщение
        closeBTN: false, // выводить кнопку закрытия окна
        // позиция по умолчанию - справа сверху
        position: {
            top: 0,
            right: 0
        }
    }, params);

    // начинаем работу с главным элементом
    // если его ещё не существует
    if (!$('#ng-stickers').length) {
        // добавляем его
        $('body').prepend('<div id="ng-stickers"></div>');
    }

    const stickers = $('#ng-stickers');

    // позиционируем
    stickers.css('position', 'fixed')
        .css({
            right: 'auto',
            left: 'auto',
            top: 'auto',
            bottom: 'auto'
        })
        .css(params.position);

    // создаём стикер
    const stick = $('<div class="alert alert-dismissible fade"></div>')
        .html(message);

    // добавляем его к родительскому элементу
    stickers.append(stick);

    // если необходимо, добавляем класс
    if (params.className) {
        stick.addClass(params.className);
    }

    // Вывод кнопки закрытия
    if (params.sticked || params.closeBTN) {
        // создаём кнопку выхода
        const exit = $('<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>');

        // вставляем её перед сообщением
        stick.prepend(exit);
    }

    // Автоматическое закрытие окна, если сообщение не закреплено.
    if (!params.sticked) {
        // Устанавливаем таймер на необходимое время.
        setTimeout(function() {
            stick.alert('close');
        }, params.time);
    }

    stick.addClass('show');
}
